SUBROUTINE Center_of_Gravity(Number_of_Cells,Cell_Node_Numbers,Node_coordinates,COG)

    Implicit None
!==================================================================================================================
    Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
    DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
    DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: COG

    Integer, INTENT(IN) :: Number_of_Cells
!==================================================================================================================
    Integer :: i,j,a1,a2,m,l
    DOUBLE PRECISION :: Xcg,Ycg,Zcg

    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: COG
    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node

    Allocate(COG(Number_of_Cells,4))
    Allocate(Node(3,4))
!==================================================================================================================
    Do i=1,Number_of_Cells
        m = 1
        Do j=2,4
            a1 = Cell_Node_Numbers(i,j)
            a2 = Cell_Node_Numbers(i,1)
            Node(m,1) = a1
            Node(m,2) = Node_coordinates(a1,2)
            Node(m,3) = Node_coordinates(a1,3)
            Node(m,4) = Node_coordinates(a1,4)
            m = m + 1
        End Do
        Xcg = 0
        Ycg = 0
        Zcg = 0
        Do l=1,3
            Xcg = Xcg + Node(l,2)
            Ycg = Ycg + Node(l,3)
            Zcg = Zcg + Node(l,4)
        End Do
        Xcg = Xcg / 3
        Ycg = Ycg / 3
        Zcg = Zcg / 3
        COG(i,1) = a2
        COG(i,2) = Xcg
        COG(i,3) = Ycg
        COG(i,4) = Zcg
    End Do
    Open(88000, file = 'COG.txt')
    Do i=1,Number_of_Cells
        Write(88000,*) COG(i,1),"   ",COG(i,2),"   ",COG(i,3),"   ",COG(i,4)
    End Do
!==================================================================================================================

End Subroutine Center_of_Gravity


