SUBROUTINE Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,CCN,&
        &Cell_Node_Numbers,nodal_normal_vector,ele_normal,Node_coordinates,LHS)

    Implicit None
!==================================================================================================================
    ! Subroutine for numerical calculation of the integral for as specific cell
    INTERFACE
    Subroutine ThreeD_to_TwoD_Triangle_Transformation(Node,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node    
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      Integer, INTENT(IN) :: integral_order,Cellindex
      DOUBLE PRECISION, INTENT(IN) :: xi,yi,zi
      DOUBLE PRECISION, INTENT(IN) :: n1,n2,n3
      DOUBLE PRECISION, INTENT(OUT) :: Int
    END SUBROUTINE ThreeD_to_TwoD_Triangle_Transformation
    END INTERFACE
!==================================================================================================================

      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: LHS
      ! LHS : Left Hand Side Matrix (Coessicien Matrix in LHS C = RHS)
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON
!==================================================================================================================

     Integer :: i,j,l,m,k,a1,a2,Cellindex,m1
     Real :: Kj,Pi,Epsilon0
     DOUBLE PRECISION :: xi,yi,zi
     DOUBLE PRECISION :: n1,n2,n3
     DOUBLE PRECISION :: Int,co1
     Real :: constant1,constant2
    
     DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node
     DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node1
     DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node2    
    
    


    Allocate(LHS(Number_of_Nodes,Number_of_Nodes))
    Allocate(Node(3,4))
    Allocate(Node1(3,4))
    Allocate(Node2(3,4))    

    Do i=1,3
        Do j=1,4
            Node(i,j) = 0.0
        End Do
    End Do    

    Epsilon0 = 8.854187817620
    Pi = 3.141592
    Kj = ((E_CON - A_CON)/(E_CON + A_CON))
    constant1 = (((-1) * Kj * (1.E12))/ (2 * Pi * Epsilon0))
    constant2 = (1.E12)/Epsilon0

    !Open(30,file='test2.txt')
    !Write(30,*)  "Epsilon0 = ", Epsilon0
    !Write(30,*)  "Pi = ", Pi
    !Write(30,*)  "Kj = ", Kj
    !Write(30,*)  "constant1 = ", constant1
    !Write(30,*)  "constant2 = ", constant2
  
    Open(10,file='test.txt')
    Do i=1,Number_of_Nodes
        Do j= 1,Number_of_Nodes
            co1 = 0
            !write(10,*) "LHS(",i,",",j,")"
            Do l=2,Number_of_Cells+1
                a1 = CCN(j,l)
                If (a1.ne.0) Then
                    !write(10,*) "a1 :", a1
                m = 1
                Do k=2,4
                    a2 = Cell_Node_Numbers(a1,k)
                    If(a2.eq.j) Then
                        Node1(1,1) = 1
                        Node1(1,2) = Node_coordinates(j,2)
                        Node1(1,3) = Node_coordinates(j,3)
                        Node1(1,4) = Node_coordinates(j,4)
                    Else
                        m = m + 1
                        Node1(m,1) = m
                        Node1(m,2) = Node_coordinates(a2,2)
                        Node1(m,3) = Node_coordinates(a2,3)
                        Node1(m,4) = Node_coordinates(a2,4)
                    End If
                End Do
                
                !write(10,*) "Node  :",Node1(1,1),"   ",Node1(1,2),"   ",Node1(1,3),"   ",Node1(1,4)
                !write(10,*) "Node  :",Node1(2,1),"   ",Node1(2,2),"   ",Node1(2,3),"   ",Node1(2,4)
                !write(10,*) "Node  :",Node1(3,1),"   ",Node1(3,2),"   ",Node1(3,3),"   ",Node1(3,4)
                
                Cellindex = a1
                !write(10,*) "Cellindex :",Cellindex

                xi = Node_coordinates(i,2)
                yi = Node_coordinates(i,3)
                zi = Node_coordinates(i,4)

                !write(10,*) "xi :",xi
                !write(10,*) "yi :",yi
                !write(10,*) "zi :",zi

                n1 = nodal_normal_vector(i,2)
                n2 = nodal_normal_vector(i,3)
                n3 = nodal_normal_vector(i,4)

                !write(10,*) "n1 :",n1
                !write(10,*) "n2 :",n2
                !write(10,*) "n3 :",n3

                !m1 = 0
                !Do k=2,4
                !    a2 = Cell_Node_Numbers(a1,k)
                !    m1 = m1 + 1
                !    Node2(m1,1) = a2
                !    Node2(m1,2) = Node_coordinates(a2,2)
                !    Node2(m1,3) = Node_coordinates(a2,3)
                !    Node2(m1,4) = Node_coordinates(a2,4)
                !End Do
                
                Call ThreeD_to_TwoD_Triangle_Transformation(Node1,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)

                !write(10,*) "Int :",Int
                co1 = co1 + Int
                End If
            End Do
             !write(10,*) "co1 :",co1
            LHS(i,j) = constant1 * co1
            !write(10,*) "LHS(",i,",",j,")","=",LHS(i,j)
            !write(10,*) "========================================================="
        End Do
    End Do
     !Open(20,file='test1.txt')
     Do i=1,Number_of_Nodes
        Do j=1,Number_of_Nodes
            If(i.eq.j) Then
                LHS(i,j) = LHS(i,j) + constant2
                !write(20,*) "LHS(",i,",",j,")","=",LHS(i,j)
            End If
        End Do
     End Do

End Subroutine