Subroutine Global_Normal_Potential(Number_of_Nodes,Number_of_Cells,CCN,ele_normal,&
    &E_CON,A_CON,current,Node_coordinates,SL,integral_order,Cell_Node_Numbers,Potential_Electrod,COG,nodal_normal_vector)

    Implicit None    
    
!==================================================================================================================
    ! Subroutine for Computation of the normal gradient of source potential (Right hand side of the final matrix equation)
    INTERFACE
    SUBROUTINE Normal_Gradient_Source_Potential(E_CON,A_CON,current,Number_of_Cells,SL,nodal_normal_vector,Node_coordinates,COG,RHS)
      Real, Allocatable, Dimension(:), INTENT(IN) :: SL
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: COG
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(OUT) :: RHS

      Integer, INTENT(IN) :: Number_of_Cells
      Real, INTENT(IN) :: E_CON,A_CON,current
    END SUBROUTINE Normal_Gradient_Source_Potential
    END INTERFACE
!==================================================================================================================
    ! Subroutine for Computation of the Left hand side of the final matrix equation
    INTERFACE
    SUBROUTINE Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,CCN,&
        &Cell_Node_Numbers,nodal_normal_vector,ele_normal,Node_coordinates,LHS)
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: LHS
     ! LHS : Left Hand Side Matrix (Coessicien Matrix in LHS C = RHS)
     Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON
    END SUBROUTINE Coefficient_Matrix
    END INTERFACE
!==================================================================================================================
    !Subroutine for Computation of the DC potential
    INTERFACE
    SUBROUTINE DC_Potential(E_CON,current,integral_order,Node_Coefficient_Electric_Charge,Number_of_Nodes,Number_of_Cells,&
    &SL,PEL,Node_coordinates,Cell_Node_Numbers,CCN,ele_normal,Half_Space_Potential,Anomaly_Potential,Potential)

    !DCP_ : DC Potential, The first letters of the subroutine's name    
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(IN) :: Node_Coefficient_Electric_Charge
      Real, Allocatable, Dimension(:), INTENT(IN) :: SL
      Real, Allocatable, Dimension(:), INTENT(IN) :: PEL
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,current
      DOUBLE PRECISION, INTENT(OUT) :: Potential
      DOUBLE PRECISION, INTENT(OUT) :: Half_Space_Potential
      DOUBLE PRECISION, INTENT(OUT) :: Anomaly_Potential
    END SUBROUTINE DC_Potential
    END INTERFACE
!==================================================================================================================
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Real, Allocatable, Dimension(:), INTENT(IN) :: SL
      Real, Allocatable, Dimension(:,:), INTENT(IN) :: Potential_Electrod
       DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: COG
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON,current
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector

!==================================================================================================================
    Integer :: ignp1
    DOUBLE PRECISION :: rgnp1,rgnp2,rgnp3,rgnp4
    ! ignp :: integer variable in the subroutine Global Normal Potential
    ! rgnp :: real variable in the subroutine Global Normal Potential
    Integer :: i,j,l,k
    Integer :: NRHS,LDA,LDB,INFO

    DOUBLE PRECISION :: normal_size
    DOUBLE PRECISION :: Potential
    DOUBLE PRECISION :: Half_Space_Potential
    DOUBLE PRECISION :: Anomaly_Potential

    Integer, Allocatable, Dimension(:) :: IPIV
    DOUBLE PRECISION, Allocatable, Dimension(:) :: RHS
    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: LHS
    DOUBLE PRECISION, Allocatable, Dimension(:) :: Node_Coefficient_Electric_Charge
    Real, Allocatable, Dimension(:) :: PEL
    DOUBLE PRECISION, Allocatable, Dimension(:) :: N_Pole_Pole_DC



    Allocate(RHS(Number_of_Cells))
    Allocate(LHS(Number_of_Cells,Number_of_Cells))
    Allocate(IPIV(Number_of_Nodes))
    Allocate(Node_Coefficient_Electric_Charge(Number_of_Cells))
    Allocate(PEL(3))
    Allocate(N_Pole_Pole_DC(251))
!==================================================================================================================
    ! Producing the right hand side of the final matrix equation which will
    ! be soleved for electrical charge node coefficients

!    Call Normal_Gradient_Source_Potential(E_CON,A_CON,current,Number_of_Cells,SL,nodal_normal_vector,Node_coordinates,COG,RHS)
!
!    Open(15,file='GNP_RHS.txt')
!    Do i=1,Number_of_Cells
!        Write(15,*)   i, "   ", RHS(i)
!    End Do
    
!==================================================================================================================
    ! Producing the Left hand side of the final matrix equation will
    ! be soleved for electrical charge node coefficients

!    Call Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,CCN,&
!        &Cell_Node_Numbers,nodal_normal_vector,ele_normal,Node_coordinates,LHS)
!        open(30,file='GNP_LHS')
!        Do i=1,Number_of_Nodes
!            Write(30,*) "LHS(",i,",","1) : ","   ",LHS(i,1)
!            Write(30,*) "LHS(",i,",","2) : ","   ",LHS(i,2)
!            Write(30,*) "LHS(",i,",","3) : ","   ",LHS(i,3)
!            Write(30,*) "LHS(",i,",","4) : ","   ",LHS(i,4)
!            Write(30,*) "LHS(",i,",","5) : ","   ",LHS(i,5)
!            Write(30,*) "LHS(",i,",","6) : ","   ",LHS(i,6)
!            Write(30,*) "LHS(",i,",","7) : ","   ",LHS(i,7)
!            Write(30,*) "LHS(",i,",","8) : ","   ",LHS(i,8)
!            Write(30,*) "LHS(",i,",","9) : ","   ",LHS(i,9)
!            Write(30,*) "LHS(",i,",","10) : ","   ",LHS(i,10)
!            Write(30,*) "LHS(",i,",","11) : ","   ",LHS(i,11)
!            Write(30,*) "LHS(",i,",","12) : ","   ",LHS(i,12)
!            Write(30,*) "LHS(",i,",","13) : ","   ",LHS(i,13)
!            Write(30,*) "LHS(",i,",","14) : ","   ",LHS(i,14)
!            Write(30,*) "LHS(",i,",","15) : ","   ",LHS(i,15)
!            Write(30,*) "LHS(",i,",","16) : ","   ",LHS(i,16)
!            Write(30,*) "================================"
!        End Do


!==================================================================================================================
   ! Solving the final matrix equation to produce the electrical charge node coefficients

!    NRHS = 1
!    LDA = Number_of_Nodes
!    LDB = Number_of_Nodes
!
!     Call dgesv(Number_of_Nodes,NRHS, LHS, LDA, IPIV, RHS, LDB, INFO)
!     If (INFO/=0) Then
!         Print*,'stop : INFO/=0',INFO
!         Stop
!     End If
!     Do i=1,Number_of_Nodes
!         Node_Coefficient_Electric_Charge(i) = RHS(i)
!     End Do


     !Open(15,file='GNP_Node_Coefficient_Electric_Charge.txt')
     !Do i=1,Number_of_Nodes
     !    Write(15,*)  i , "     ", Node_Coefficient_Electric_Charge(i)
     !End Do
!==================================================================================================================
     !Calculation of the DC electrical Potential

    ! Do i=1,251
    !    PEL(1) = Potential_Electrod(i,1)
    !    PEL(2) = Potential_Electrod(i,2)
    !    PEL(3) = Potential_Electrod(i,3)
    !Call DC_Potential(E_CON,current,integral_order,Node_Coefficient_Electric_Charge,Number_of_Nodes,Number_of_Cells,&
    !&SL,PEL,Node_coordinates,Cell_Node_Numbers,CCN,ele_normal,Half_Space_Potential,Anomaly_Potential,Potential)

!    N_Pole_Pole_DC(i) = Anomaly_Potential

 !   End Do

  !  Open(20000,file='N_Pole_Pole_DC.txt')
  !  k=0
  !  Do i=1,251
  !  Write(20000,*)   k,"  ",N_Pole_Pole_DC(i)
  !  k = k+10
  !  End Do


End Subroutine Global_Normal_Potential






















