SUBROUTINE Local_Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,&
        &Cell_Node_Numbers,ele_normal,Node_coordinates,COG,Local_LHS)

    Implicit None
!==================================================================================================================     
      ! Subroutine for numerical calculation of the integral for as specific cell
    INTERFACE
    Subroutine ThreeD_to_TwoD_Triangle_Transformation(Node,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node   
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      Integer, INTENT(IN) :: integral_order,Cellindex
      DOUBLE PRECISION, INTENT(IN) :: xi,yi,zi
      DOUBLE PRECISION, INTENT(IN) :: n1,n2,n3
      DOUBLE PRECISION, INTENT(OUT) :: Int
    END SUBROUTINE ThreeD_to_TwoD_Triangle_Transformation
    END INTERFACE
!==================================================================================================================

      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: COG
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: Local_LHS
     ! LHS : Left Hand Side Matrix (Coessicien Matrix in LHS C = RHS)
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON
!==================================================================================================================
    Integer :: i,j,l,m,k,a1,a2,Cellindex,m1
     Real :: Kj,Pi,Epsilon0
     DOUBLE PRECISION :: xi,yi,zi
     DOUBLE PRECISION :: n1,n2,n3
     DOUBLE PRECISION :: Int
     Real :: constant1,constant2


    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node    
    

    Allocate(Local_LHS(Number_of_Cells,Number_of_Cells))
    Allocate(Node(3,4))    


    Do i=1,3
        Do j=1,4
            Node(i,j) = 0.0
        End Do
    End Do    

    Epsilon0 = 8.854187817620
    Pi = 3.141592
    Kj = ((E_CON - A_CON)/(E_CON + A_CON))        
    constant1 = (((-1) * Kj * (1.E12))/ (2 * Pi * Epsilon0))
    constant2 = (1.E12)/Epsilon0
    



    Do i=1,Number_of_Cells        
        Do j=1,Number_of_Cells                       
                m1 = 0
                Do k=2,4
                    a2 = Cell_Node_Numbers(j,k)
                    m1 = m1 + 1
                    Node(m1,1) = a2
                    Node(m1,2) = Node_coordinates(a2,2)
                    Node(m1,3) = Node_coordinates(a2,3)
                    Node(m1,4) = Node_coordinates(a2,4)
                End Do

                Cellindex = j

                xi = COG(i,2)
                yi = COG(i,3)
                zi = COG(i,4)

                n1 = ele_normal(i,2)
                n2 = ele_normal(i,3)
                n3 = ele_normal(i,4)
                

                Call ThreeD_to_TwoD_Triangle_Transformation(Node,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)
                
                Local_LHS(i,j) = constant1 * Int
                !Print*, "Local_LHS(",i,",",j,")",Local_LHS(i,j)               
            End Do            
        End Do

     Do i=1,Number_of_Cells
        Do j=1,Number_of_Cells
            If(i.eq.j) Then
                Local_LHS(i,j) = constant2 - Local_LHS(i,j)
            End If
        End Do
     End Do     


End Subroutine Local_Coefficient_Matrix
