Subroutine Outward_Nodal_Normal_Vector(Number_of_Nodes,Number_of_Cells,CCN,ele_normal,nodal_normal_vector)

    Implicit None

!==================================================================================================================
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: nodal_normal_vector

      
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells
!==================================================================================================================
    Integer :: ignp1
    DOUBLE PRECISION :: rgnp1,rgnp2,rgnp3,rgnp4
    ! ignp :: integer variable in the subroutine Global Normal Potential
    ! rgnp :: real variable in the subroutine Global Normal Potential
    Integer :: i,j,l,k
    Integer :: NRHS,LDA,LDB,INFO
    DOUBLE PRECISION :: normal_size


    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: nodal_normal_vector

    Allocate(nodal_normal_vector(Number_of_Nodes,4))

!==================================================================================================================
    ! Computation of the normal vector for each node by averaging the normal
    ! vectors of the cells which share that node
    Do i=1,Number_of_Nodes
          Do j=1,4
              nodal_normal_vector(i,j) = 0
          End Do
      End Do

      !Open(10,file='Nodal_normal.txt')
      !Open(20,file='Nodal_CCN.txt')
      Do j= 1,Number_of_Nodes
            rgnp1 = 0
            rgnp2 = 0
            rgnp3 = 0
            i = 0
            !Write(20,*) "Node_Number : ", j
            Do l=2,Number_of_Cells+1
                ignp1 = CCN(j,l)
                If (ignp1.ne.0) Then
                 !Write(20,*) "Cell_Number : ", ignp1
                 i = i+1
                 rgnp1 = rgnp1 + ele_normal(ignp1,2)
                 rgnp2 = rgnp2 + ele_normal(ignp1,3)
                 rgnp3 = rgnp3 + ele_normal(ignp1,4)
                End If
            End Do
            !Write(20,*) "==========================="
            rgnp1 = rgnp1 / i
            rgnp2 = rgnp2 / i
            rgnp3 = rgnp3 / i
            normal_size = (rgnp1**2 + rgnp2**2 + rgnp3**2)**(0.5)
            nodal_normal_vector(j,1) = j
            nodal_normal_vector(j,2) = rgnp1 / normal_size
            nodal_normal_vector(j,3) = rgnp2 / normal_size
            nodal_normal_vector(j,4) = rgnp3 / normal_size
            rgnp4 = (nodal_normal_vector(j,2)**2 + nodal_normal_vector(j,3)**2 + nodal_normal_vector(j,4)**2)**(0.5)
            !Write(10,*) "Node_Number : ", j
            !Write(10,*) "Number of Cells that share tha node : ", i
            !Write(10,*) "Normal_X_component : ", nodal_normal_vector(j,2)
            !Write(10,*) "Normal_Y_component : ", nodal_normal_vector(j,3)
            !Write(10,*) "Normal_Z_component : ", nodal_normal_vector(j,4)
            !Write(10,*) "Normal_Size : ", rgnp4
            !Write(10,*) "==========================="
      End Do
!==================================================================================================================

       End Subroutine Outward_Nodal_Normal_Vector