SUBROUTINE Normal_Gradient_Source_Potential(E_CON,A_CON,current,Number_of_Cells,SL,ele_normal,COG,RHS)
        

    Implicit None
!==================================================================================================================
    Real, Allocatable, Dimension(:), INTENT(IN) :: SL            
    DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: COG
    DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
    DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(OUT) :: RHS

    Integer, INTENT(IN) :: Number_of_Cells
    Real, INTENT(IN) :: E_CON,A_CON,current
!==================================================================================================================

    Integer :: i,j,a1,a2,m,l
    Real :: C,Pi,Kj
    DOUBLE PRECISION :: Nom1,Nom2,Nom3,Nom4,Den1,Den2
    DOUBLE PRECISION :: Xcg,Ycg,Zcg

    DOUBLE PRECISION, Allocatable, Dimension(:) :: RHS
    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node

    Allocate(RHS(Number_of_Cells))
    Allocate(Node(3,4))
!==================================================================================================================
    Pi = 3.141592
    Kj = (E_CON - A_CON)/(E_CON + A_CON)
    C = (current * Kj)/(2 * Pi * E_CON)
!==================================================================================================================
    Do i=1,Number_of_Cells
        RHS(i) = 0.0
    End Do

    Do i=1,Number_of_Cells

        Nom1 = ele_normal(i,2) * (SL(1) - COG(i,2))
        Nom2 = ele_normal(i,3) * (SL(2) - COG(i,3))
        Nom3 = ele_normal(i,4) * (SL(3) - COG(i,4))
        Nom4 = ele_normal(i,4) * (-1) * (SL(3) + COG(i,4))

        Den1 =  ((COG(i,2) - SL(1))**2 + (COG(i,3) - SL(2))**2 + (COG(i,4) - SL(3))**2)**(1.5)
        Den2 =  ((COG(i,2) - SL(1))**2 + (COG(i,3) - SL(2))**2 + (COG(i,4) + SL(3))**2)**(1.5)

        RHS(i) = C * (((Nom1+Nom2+Nom3)/(Den1)) + ((Nom1+Nom2+Nom4)/(Den2)))
    End Do
!==================================================================================================================
End SUBROUTINE