Program Test_Integral

    Implicit None
  !==================================================================================================================

     Integer :: i,j
     Real :: LNS1,LNS2,LNS3
     DOUBLE PRECISION :: jacobian1,jacobian2 ,Cons,ZZ,Int1
    ! Cons : N1
    ! Z : ZZ
     DOUBLE PRECISION :: Denominator11,Denominator12,Denominator13,Denominator14
     DOUBLE PRECISION :: Den1,Den2
     DOUBLE PRECISION :: TSF ! Transformed Shape Function
     DOUBLE PRECISION :: Nominator11,Nominator12,Nominator13,Nominator14
     DOUBLE PRECISION :: Nom1,Nom2
     DOUBLE PRECISION :: xi,yi,zi,n1,n2,n3
     DOUBLE PRECISION :: xip,yip,zip
     Integer :: integral_order
     DOUBLE PRECISION :: Int
     DOUBLE PRECISION :: Sxy,Syz,Szx,Costeta,Sinteta,Cosphi,Sinphi,delta,delta1,delta2
     DOUBLE PRECISION :: xtr1,ytr1,ztr1
     DOUBLE PRECISION :: xtr2,ytr2
     DOUBLE PRECISION :: alpha,beta
     
     
     DOUBLE PRECISION, Allocatable, Dimension(:) :: x
     DOUBLE PRECISION, Allocatable, Dimension(:) :: y
     DOUBLE PRECISION, Allocatable, Dimension(:) :: z
     DOUBLE PRECISION, Allocatable, Dimension(:) :: U
     DOUBLE PRECISION, Allocatable, Dimension(:) :: V
     DOUBLE PRECISION, Allocatable, Dimension(:) :: W
     DOUBLE PRECISION, Allocatable, Dimension(:) :: a
     DOUBLE PRECISION, Allocatable, Dimension(:) :: b
     DOUBLE PRECISION, Allocatable, Dimension(:) :: c
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Weight
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Xk
     DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node
     DOUBLE PRECISION, Allocatable, Dimension(:) :: BF     
     
    Allocate(x(3))
    Allocate(y(3))
    Allocate(z(3))
    Allocate(U(3))
    Allocate(V(3))
    Allocate(W(3))
    Allocate(a(3))
    Allocate(b(3))
    Allocate(c(3))
    Allocate(Weight(6))
    Allocate(Xk(6))
    Allocate(Node(3,4))
    Allocate(BF(4))
    
    Do i=1,3
        x(i) = 0.0
        y(i) = 0.0
        z(i) = 0.0
        U(i) = 0.0
        V(i) = 0.0
        W(i) = 0.0
        a(i) = 0.0
        b(i) = 0.0
        c(i) = 0.0               
    End Do
    Do i=1,6
        Weight(i) = 0.0
        Xk(i) = 0.0        
    End Do
    !==================================================================================================================
    ! (Node,BF,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)
    Node(3,1) = 49
    Node(3,2) =  0.139387500000E+04
    Node(3,3) =  0.350000030000E+03
    Node(3,4) = -0.452500000000E+03

    Node(1,1) = 2
    Node(1,2) =  0.139387500000E+04
    Node(1,3) =  0.350000000000E+03
    Node(1,4) = -0.452500000000E+03
    

    Node(2,1) = 1
    Node(2,2) =  0.132250000000E+04
    Node(2,3) =  0.350000000000E+03
    Node(2,4) = -0.381125060000E+03

    BF(1) = 12.934333941977 
    BF(2) = -0.0070052598298401
    BF(3) = 0.0
    BF(4) = 0.0070052539399005

    LNS1 = 0.707106483979E+00
    LNS2 = 0.000000000000E+00
    LNS3 = 0.707107078394E+00

    xi =  0.132250000000E+04
    yi =  0.350000000000E+03
    zi = -0.381125060000E+03

    n1 = 0.707106483979E+00
    n2 = 0.000000000000E+00
    n3 = 0.707107078394E+00

    integral_order = 2


    !==================================================================================================================
    
    ! Reading the Original_Triangle vertex coordinates
    Do i=1,3
        x(i) = Node(i,2)
        y(i) = Node(i,3)
        z(i) = Node(i,4)
    End Do

    !LNS1 = ele_normal(Cellindex,2)
    !LNS2 = ele_normal(Cellindex,3)
    !LNS3 = ele_normal(Cellindex,4)
    

    If(z(1).eq.z(2).and.z(1).eq.z(3)) Then
        If(LNS3.gt.0.0) Then
            Sinteta = 0.0
            Costeta = 1.0
            Sinphi = 0.0
            Cosphi = 1.0       
        Else
            Sinteta = 0.0
            Costeta = 1.0
            Sinphi = 0.0
            Cosphi = -1.0
        End If
        Else
        If(y(1).eq.y(2).and.y(1).eq.y(3)) Then
            If(LNS2.gt.0.0) Then
                Sinteta = 1.0
                Costeta = 0.0
                Sinphi = -1.0
                Cosphi =  0.0            
            Else
                Sinteta = -1.0
                Costeta = 0.0
                Sinphi = 1.0
                Cosphi = 0.0                
            End If            
        Else
        If (x(1).eq.x(2).and.x(1).eq.x(3)) Then
             If(LNS1.gt.0.0) Then
                Sinteta = 0.0
                Costeta = 1.0
                Sinphi =  -1.0
                Cosphi = 0.0
             Else
                Sinteta = 0.0
                Costeta = -1.0
                Sinphi =  1.0
                Cosphi = 0.0
             End If
            Else
    Sxy = x(1)*(y(2)-y(3)) + x(2)*(y(3)-y(1)) + x(3)*(y(1)-y(2))
    Syz = y(1)*(z(2)-z(3)) + y(2)*(z(3)-z(1)) + y(3)*(z(1)-z(2))
    Szx = z(1)*(x(2)-x(3)) + z(2)*(x(3)-x(1)) + z(3)*(x(1)-x(2))
    Costeta = ((-1) * Syz)/((Syz**2 + Szx**2)**(0.5))
    Sinteta = ((-1) * Szx)/((Syz**2 + Szx**2)**(0.5))
    Cosphi = ((-1) * Sxy)/((Syz**2 + Szx**2 + Sxy**2)**(0.5))
    Sinphi = ((Syz**2 + Szx**2)/(Syz**2 + Szx**2 + Sxy**2))**(0.5)    
            End If
        End If
    End If

    Do i=1,3
        U(i) = x(i)* Cosphi * Costeta + y(i) * Sinteta * Cosphi - Sinphi * z(i)
        V(i) = (-1) * x(i)* Sinteta + y(i) * Costeta
        W(i) = x(i) * Sinphi * Costeta + y(i) * Sinphi * Sinteta + Cosphi * z(i)
    End Do

    ZZ = W(1)

    a(1) = U(2)*V(3) - V(2)*U(3)
    a(2) = U(3)*V(1) - V(3)*U(1)
    a(3) = U(1)*V(2) - V(1)*U(2)
    b(1) = V(2) - V(3)
    b(2) = V(3) - V(1)
    b(3) = V(1) - V(2)
    c(1) = U(3) - U(2)
    c(2) = U(1) - U(3)
    c(3) = U(2) - U(1)
    delta = (0.5) * (b(1)*c(2)-b(2)*c(1))
    Cons = (0.5) * (delta) * (b(1) * U(1) + b(2) * U(2) + b(3) * U(3))
    Open(10,file='Test_Integral.txt.')
    write(10,*) "Node  :",Node(3,1)," ",Node(3,2)," ",Node(3,3)," ",Node(3,4)
    !Write(1000,*) "Cellindex = ", Cellindex
    Write(10,*) "delta = ", delta
    Write(10,*) "Cons = ", Cons
    !==================================================================================================================
    ! Calculation of the jacobians for the previous two transformation which must be multiplied to the integrand
    !Jacobian1 = abs    (costeta*cosphi   -sinteta   sinphi*costeta)
    !                det(sinteta*cosphi    costeta   sinteta*sinphi)
    !                   (-sinphi             0.0         cosphi    )
    jacobian1 = 1.0
    jacobian2 = abs((2 * Cons**2)/(delta**3))
    Write(10,*) "jacobian1 = ", jacobian1
    Write(10,*) "jacobian2 = ", jacobian2
    Write(10,*) "========================================="
    !==================================================================================================================

    ! Applying the transformation to calculate integral numerically and approximating the integral numerically    

    ! Building up the weighting function (W) and the Gaussian Quadrature points (Xk)
    ! based on the order of integration(integral_order)

    If(integral_order.eq.2) Then
        Xk(1) =  0.5773502692
        Xk(2) = -0.5773502692
        Weight(1) = 1.0
        Weight(2) = 1.0
        Do i=3,6
            Xk(i) = 0.0
            Weight(i) = 0.0
        End Do
    End If

    If(integral_order.eq.3) Then
        Xk(1) = 0.7745966692
        Xk(2) = 0.0000000000
        Xk(3) = -0.7745966692
        Weight(1) = 0.5555555555
        Weight(2) = 0.8888888888
        Weight(3) = 0.5555555555
        Do i=4,6
            Xk(i) = 0.0
            Weight(i) = 0.0
        End Do
    End If

    If(integral_order.eq.4) Then
        Xk(1) = 0.8611363116
        Xk(2) = 0.3399810436
        Xk(3) = -0.3399810436
        Xk(4) = -0.8611363116
        Weight(1) = 0.3478548451
        Weight(2) = 0.6521451549
        Weight(3) = 0.6521451549
        Weight(4) = 0.3478548451
        Do i=5,6
            Xk(i) = 0.0
            Weight(i) = 0.0
        End Do
    End If

    If(integral_order.eq.5) Then
        Xk(1) = 0.9061798459
        Xk(2) = 0.5384693101
        Xk(3) = 0.0000000000
        Xk(4) = -0.5384693101
        Xk(5) = -0.9061798459
        Xk(6) = 0.0
        Weight(1) = 0.2369268850
        Weight(2) = 0.4786286205
        Weight(3) = 0.5688888889
        Weight(4) = 0.4786286205
        Weight(5) = 0.2369268850
        Weight(6) = 0.0
    End If

    If(integral_order.eq.6) Then
        Xk(1) = 0.9324695142
        Xk(2) = 0.6612093865
        Xk(3) = 0.2386191861
        Xk(4) = -0.2386191861  ! There is no minus sign for this in the book but I guess this must have it
        Xk(5) = -0.6612093865
        Xk(6) = -0.9324695142
        Weight(1) = 0.1713244924
        Weight(2) = 0.3607615730
        Weight(3) = 0.4679139346
        Weight(4) = 0.4679139346
        Weight(5) = 0.3607615730
        Weight(6) = 0.1713244924
    End If

    !==================================================================================================================

    Int = 0.0
    Do i=1,integral_order
        Int1 = 0.0
        Do j=1,integral_order

    ! Coordinate System transformations
    ! From a general 3D Triangle to 2D standard Traiangle 

    alpha = ((1 + Xk(i)) * (1 + Xk(i)))/4 
    beta  = ((1 + Xk(i)) * (1 - Xk(i)))/4

    Write(10,*) "i = ", i
    Write(10,*) "j = ", j
    Write(10,*) "alpha = ", alpha
    Write(10,*) "beta = ", beta
    Write(10,*) "xi = ", xi
    Write(10,*) "yi = ", yi
    Write(10,*) "zi = ", zi 
    Write(10,*) "========================================="

    delta1 = delta**2
    delta2 = 2 * delta
    xtr2 = ((Cons * c(2))/delta1)*alpha - ((a(1) * c(2))/delta2) - ((Cons * c(1))/delta1)*beta + ((a(2) * c(1))/delta2)
    ytr2 = (((-1) * Cons * b(2))/delta1)*alpha + ((a(1) * b(2))/delta2) + ((Cons * b(1))/delta1)*beta - ((a(2) * b(1))/delta2) 

    Write(10,*) "delta1 = ", delta1
    Write(10,*) "delta2 = ", delta2
    Write(10,*) "xtr2 = ", xtr2
    Write(10,*) "ytr2 = ", ytr2
    Write(10,*) "========================================="

    xtr1 = (Costeta * Cosphi * xtr2) - (Sinteta * ytr2) + (Sinphi * Costeta * ZZ)
    ytr1 = (Sinteta * Cosphi * xtr2) + (Costeta * ytr2) + (Sinphi * Sinteta * ZZ)
    ztr1 = ((-1) * Sinphi * xtr2) + (Cosphi * ZZ)
    Write(10,*) "xtr1 = ", xtr1
    Write(10,*) "ytr1 = ", ytr1
    Write(10,*) "ztr1 = ", ztr1
    Write(10,*) "ZZ = ", ZZ
    Write(10,*) "========================================="

    xip = xtr1
    yip = ytr1
    zip = ztr1

    Write(10,*) "xip = ", xip
    Write(10,*) "yip = ", yip
    Write(10,*) "zip = ", zip  
    Write(10,*) "========================================="

    ! Denominator1 = (r-r')^(3/2) = ((x-x')^2 + (y-y')^2 + (z-z')^2)^(3/2)
    ! Denominator1  : Den1 = (Denominator11 + Denominator12 + Denominator13)**(1.5)

   Denominator11 = (xi - xip)**2
   Denominator12 = (yi - yip)**2
   Denominator13 = (zi - zip)**2
   Denominator14 = (zi + zip)**2

    Write(10,*) "Denominator11 = ", Denominator11
    Write(10,*) "Denominator12 = ", Denominator12
    Write(10,*) "Denominator13 = ", Denominator13
    Write(10,*) "Denominator14 = ", Denominator14
    Write(10,*) "========================================="

   Den1 = (Denominator11 + Denominator12 + Denominator13)**(1.5)

   ! Denominator2 = (r-r'')^(3/2) = ((x-x')^2 + (y-y')^2 + (z+z')^2)^(3/2)
   ! Denominator2  : Den2 = (Denominator11 + Denominator12 + Denominator14)**(1.5)

   Den2 = (Denominator11 + Denominator12 + Denominator14)**(1.5)

    Write(10,*) "Den1 = ", Den1
    Write(10,*) "Den2 = ", Den2
    Write(10,*) "========================================="

   ! Nom1 =  n1 * (x-x') + n2 * (y-y') + n3 * (z - z')
   ! Nom1 = (Nominator11 + Nominator12 + Nominator13)       
   
   Nominator11 = n1 * (xip - xi)
   Nominator12 = n2 * (yip - yi)
   Nominator13 = n3 * (zip - zi)
   Nominator14 = (-1) * n3 * (zi + zip)
    Write(10,*) "Nominator11 = ", Nominator11
    Write(10,*) "Nominator12 = ", Nominator12
    Write(10,*) "Nominator13 = ", Nominator13
    Write(10,*) "Nominator14 = ", Nominator14
    Write(10,*) "========================================="

   Nom1 = Nominator11 + Nominator12 + Nominator13

   ! Nom2 =  n1 * (x-x') + n2 * (y-y') - n3 * (z + z')
   ! Nom2 = (Nominator11 + Nominator12 + Nominator14)

   Nom2 = Nominator11 + Nominator12 + Nominator14

    Write(10,*) "Nom1 = ", Nom1
    Write(10,*) "Nom2 = ", Nom2
    Write(10,*) "========================================="

   ! Transformed basic function

   TSF = BF(1) + BF(2) * xip +  BF(3) * yip +  BF(4) * zip

    Write(10,*) "TSF = ", TSF    
    Write(10,*) "========================================="

   Int1 = Int1 + ((1+Xk(i))/8) * Weight(i) * Weight(j) * jacobian1 * jacobian2 * TSF * ((Nom1/Den1) + (Nom2/Den2))
    Write(10,*) "Int1 = ", Int1    
    Write(10,*) "========================================="

   End Do
        Int = Int + Int1        
        Write(10,*) "Int = ", Int    
        Write(10,*) "========================================="
    End Do
    Write(10,*) "Int = ", Int    
        Write(10,*) "================================================================================================"
    Print*, Int
    End Program Test_Integral