Subroutine Anomaly_Potential_Integral(Node,BF,Cellindex,ele_normal,xi,yi,zi,integral_order,Int)

    Implicit None
!==================================================================================================================
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(IN) :: BF
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      Integer, INTENT(IN) :: integral_order,Cellindex
      Real, INTENT(IN) :: xi,yi,zi
      DOUBLE PRECISION, INTENT(OUT) :: Int
!==================================================================================================================

     Integer :: i,j
     DOUBLE PRECISION :: LNS1,LNS2,LNS3
     DOUBLE PRECISION :: jacobian1,jacobian2 ,Cons,ZZ,Int1
    ! Cons : N1
    ! Z : ZZ
     DOUBLE PRECISION :: Denominator11,Denominator12,Denominator13,Denominator14
     DOUBLE PRECISION :: Den1,Den2
     DOUBLE PRECISION :: TSF! Transformed Shape Function
     DOUBLE PRECISION :: Nom1,Nom2,Nom3
     Real :: xi,yi,zi
     DOUBLE PRECISION :: xip,yip,zip
     DOUBLE PRECISION :: Int
     DOUBLE PRECISION :: Sxy,Syz,Szx,Costeta,Sinteta,Cosphi,Sinphi,delta,delta1,delta2
     DOUBLE PRECISION :: xtr1,ytr1,ztr1
     DOUBLE PRECISION :: xtr2,ytr2
     DOUBLE PRECISION :: alpha,beta
     

     DOUBLE PRECISION, Allocatable, Dimension(:) :: x
     DOUBLE PRECISION, Allocatable, Dimension(:) :: y
     DOUBLE PRECISION, Allocatable, Dimension(:) :: z
     DOUBLE PRECISION, Allocatable, Dimension(:) :: U
     DOUBLE PRECISION, Allocatable, Dimension(:) :: V
     DOUBLE PRECISION, Allocatable, Dimension(:) :: W
     DOUBLE PRECISION, Allocatable, Dimension(:) :: a
     DOUBLE PRECISION, Allocatable, Dimension(:) :: b
     DOUBLE PRECISION, Allocatable, Dimension(:) :: c
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Weight
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Xk

    Allocate(x(3))
    Allocate(y(3))
    Allocate(z(3))
    Allocate(U(3))
    Allocate(V(3))
    Allocate(W(3))
    Allocate(a(3))
    Allocate(b(3))
    Allocate(c(3))
    Allocate(Weight(6))
    Allocate(Xk(6))


    Do i=1,3
        x(i) = 0.0
        y(i) = 0.0
        z(i) = 0.0
        U(i) = 0.0
        V(i) = 0.0
        W(i) = 0.0
        a(i) = 0.0
        b(i) = 0.0
        c(i) = 0.0
    End Do
    Do i=1,6
        Weight(i) = 0.0
        Xk(i) = 0.0
    End Do    
    !==================================================================================================================
    ! Reading the Original_Triangle vertex coordinates
    Do i=1,3
        x(i) = Node(i,2)
        y(i) = Node(i,3)
        z(i) = Node(i,4)
    End Do

    LNS1 = ele_normal(Cellindex,2)
    LNS2 = ele_normal(Cellindex,3)
    LNS3 = ele_normal(Cellindex,4)

    If(z(1).eq.z(2).and.z(1).eq.z(3)) Then
        If(LNS3.gt.0.0) Then
            Sinteta = 0.0
            Costeta = 1.0
            Sinphi = 0.0
            Cosphi = 1.0
        Else
            Sinteta = 0.0
            Costeta = 1.0
            Sinphi = 0.0
            Cosphi = -1.0
        End If
        Else
        If(y(1).eq.y(2).and.y(1).eq.y(3)) Then
            If(LNS2.gt.0.0) Then
                Sinteta = 1.0
                Costeta = 0.0
                Sinphi = -1.0
                Cosphi =  0.0
            Else
                Sinteta = -1.0
                Costeta = 0.0
                Sinphi = 1.0
                Cosphi = 0.0
            End If
        Else
        If (x(1).eq.x(2).and.x(1).eq.x(3)) Then
             If(LNS1.gt.0.0) Then
                Sinteta = 0.0
                Costeta = 1.0
                Sinphi =  -1.0
                Cosphi = 0.0
             Else
                Sinteta = 0.0
                Costeta = -1.0
                Sinphi =  1.0
                Cosphi = 0.0
             End If
            Else
    Sxy = x(1)*(y(2)-y(3)) + x(2)*(y(3)-y(1)) + x(3)*(y(1)-y(2))
    Syz = y(1)*(z(2)-z(3)) + y(2)*(z(3)-z(1)) + y(3)*(z(1)-z(2))
    Szx = z(1)*(x(2)-x(3)) + z(2)*(x(3)-x(1)) + z(3)*(x(1)-x(2))
    Costeta = ((-1) * Syz)/((Syz**2 + Szx**2)**(0.5))
    Sinteta = ((-1) * Szx)/((Syz**2 + Szx**2)**(0.5))
    Cosphi = ((-1) * Sxy)/((Syz**2 + Szx**2 + Sxy**2)**(0.5))
    Sinphi = ((Syz**2 + Szx**2)/(Syz**2 + Szx**2 + Sxy**2))**(0.5)
            End If
        End If
    End If

    Do i=1,3
        U(i) = x(i)* Cosphi * Costeta + y(i) * Sinteta * Cosphi - Sinphi * z(i)
        V(i) = (-1) * x(i)* Sinteta + y(i) * Costeta
        W(i) = x(i) * Sinphi * Costeta + y(i) * Sinphi * Sinteta + Cosphi * z(i)
    End Do

    ZZ = W(1)

    a(1) = U(2)*V(3) - V(2)*U(3)
    a(2) = U(3)*V(1) - V(3)*U(1)
    a(3) = U(1)*V(2) - V(1)*U(2)
    b(1) = V(2) - V(3)
    b(2) = V(3) - V(1)
    b(3) = V(1) - V(2)
    c(1) = U(3) - U(2)
    c(2) = U(1) - U(3)
    c(3) = U(2) - U(1)
    delta = (0.5) * (b(1)*c(2)-b(2)*c(1))
    Cons = (0.5) * (delta) * (b(1) * U(1) + b(2) * U(2) + b(3) * U(3))    
   !==================================================================================================================
    ! Calculation of the jacobians for the previous two transformation which must be multiplied to the integrand
    !Jacobian1 = abs    (costeta*cosphi   -sinteta   sinphi*costeta)
    !                det(sinteta*cosphi    costeta   sinteta*sinphi)
    !                   (-sinphi             0.0         cosphi    )
    jacobian1 = 1.0
    jacobian2 = abs((2 * Cons**2)/(delta**3))    
    !==================================================================================================================
     ! Applying the transformation to calculate integral numerically and approximating the integral numerically
    !  u to (1+ξ)*(1+η)/4
    !  v to (1+ξ)*(1-η)/4
    !  jacobian3 = (1+ξ)/8
    !  Integral = Σi Σj (1+ξ)/8 W(i)W(j) F(u(ξ,η),v(ξ,η))

    ! Building up the weighting function (W) and the Gaussian Quadrature points (Xk)
    ! based on the order of integration(integral_order)

    If(integral_order.eq.2) Then
        Xk(1) =  0.5773502692
        Xk(2) = -0.5773502692
        Weight(1) = 1.0
        Weight(2) = 1.0
        Do i=3,6
            Xk(i) = 0.0
            Weight(i) = 0.0
        End Do
    End If

    If(integral_order.eq.3) Then
        Xk(1) = 0.7745966692
        Xk(2) = 0.0000000000
        Xk(3) = -0.7745966692
        Weight(1) = 0.5555555555
        Weight(2) = 0.8888888888
        Weight(3) = 0.5555555555
        Do i=4,6
            Xk(i) = 0.0
            Weight(i) = 0.0
        End Do
    End If

    If(integral_order.eq.4) Then
        Xk(1) = 0.8611363116
        Xk(2) = 0.3399810436
        Xk(3) = -0.3399810436
        Xk(4) = -0.8611363116
        Weight(1) = 0.3478548451
        Weight(2) = 0.6521451549
        Weight(3) = 0.6521451549
        Weight(4) = 0.3478548451
        Do i=5,6
            Xk(i) = 0.0
            Weight(i) = 0.0
        End Do
    End If

    If(integral_order.eq.5) Then
        Xk(1) = 0.9061798459
        Xk(2) = 0.5384693101
        Xk(3) = 0.0000000000
        Xk(4) = -0.5384693101
        Xk(5) = -0.9061798459
        Xk(6) = 0.0
        Weight(1) = 0.2369268850
        Weight(2) = 0.4786286205
        Weight(3) = 0.5688888889
        Weight(4) = 0.4786286205
        Weight(5) = 0.2369268850
        Weight(6) = 0.0
    End If

    If(integral_order.eq.6) Then
        Xk(1) = 0.9324695142
        Xk(2) = 0.6612093865
        Xk(3) = 0.2386191861
        Xk(4) = -0.2386191861  ! There is no minus sign for this in the book but I guess this must have it
        Xk(5) = -0.6612093865
        Xk(6) = -0.9324695142
        Weight(1) = 0.1713244924
        Weight(2) = 0.3607615730
        Weight(3) = 0.4679139346
        Weight(4) = 0.4679139346
        Weight(5) = 0.3607615730
        Weight(6) = 0.1713244924
    End If
    !==================================================================================================================
    ! The Integral is:
    ! Integral(N(r') * (1/r-r')+(1/r-r'')) dS
    !==================================================================================================================
    ! Second Approach : where i directly replaced the variables by the new one in the new coordinates system


    ! Denominator2 = (r-r'')^(1/2) = ((x-x')^2 + (y-y')^2 + (z+z')^2)^(1/2)
    ! Denominator2  : Den1 = (Denominator11 + Denominator12 + Denominator14)**(0.5)

    Int = 0.0
    Do i=1,integral_order
        Int1 = 0.0
        Do j=1,integral_order

    ! Coordinate System transformations
    ! From a general 3D Triangle to 2D standard Traiangle

    alpha = ((1 + Xk(i)) * (1 + Xk(j)))/4
    beta  = ((1 + Xk(i)) * (1 - Xk(j)))/4   

    delta1 = delta**2
    delta2 = 2 * delta
    xtr2 = ((Cons * c(2))/delta1)*alpha - ((a(1) * c(2))/delta2) - ((Cons * c(1))/delta1)*beta + ((a(2) * c(1))/delta2)
    ytr2 = (((-1) * Cons * b(2))/delta1)*alpha + ((a(1) * b(2))/delta2) + ((Cons * b(1))/delta1)*beta - ((a(2) * b(1))/delta2)    

    xtr1 = (Costeta * Cosphi * xtr2) - (Sinteta * ytr2) + (Sinphi * Costeta * ZZ)
    ytr1 = (Sinteta * Cosphi * xtr2) + (Costeta * ytr2) + (Sinphi * Sinteta * ZZ)
    ztr1 = ((-1) * Sinphi * xtr2) + (Cosphi * ZZ)    

    xip = xtr1
    yip = ytr1
    zip = ztr1    

    ! Denominator1 = (r-r')^(1/2) = ((x-x')^2 + (y-y')^2 + (z-z')^2)^(1/2)
    ! Denominator1  : Den1 = (Denominator11 + Denominator12 + Denominator13)**(0.5)

   Denominator11 = (xi - xip)**2
   Denominator12 = (yi - yip)**2
   Denominator13 = (zi - zip)**2
   Denominator14 = (zi + zip)**2    

   Den1 = (Denominator11 + Denominator12 + Denominator13)**(0.5)

   ! Denominator2 = (r-r'')^(3/2) = ((x-x')^2 + (y-y')^2 + (z+z')^2)^(3/2)
   ! Denominator2  : Den2 = (Denominator11 + Denominator12 + Denominator14)**(1.5)

   Den2 = (Denominator11 + Denominator12 + Denominator14)**(0.5)   

    ! Transformed basic function

    TSF = BF(1) + BF(2) * xip +  BF(3) * yip +  BF(4) * zip   

    Nom1 = TSF * 1
    Nom2 = TSF * 1   
    
    Int1 = Int1 + ((1+Xk(i))/8) * Weight(i) * Weight(j) * jacobian1 * jacobian2 * ((Nom1/Den1) + (Nom2/Den2))    

   End Do
        Int = Int + Int1        
    End Do    
End Subroutine Anomaly_Potential_Integral