Subroutine Basis_Functions_Triangle(Node,Cellindex,ele_normal,BF)

    Implicit None
!==================================================================================================================
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(OUT) :: BF
      Integer, INTENT(IN) :: Cellindex
!==================================================================================================================

     Integer :: i,j
     Real :: LNS1,LNS2,LNS3  ! local(element) normal sign
     DOUBLE PRECISION :: Sxy,Syz,Szx,Costeta,Sinteta,Cosphi,Sinphi,delta
     DOUBLE PRECISION :: eta,Coseta
     DOUBLE PRECISION :: node_shape

     DOUBLE PRECISION, Allocatable, Dimension(:) :: x
     DOUBLE PRECISION, Allocatable, Dimension(:) :: y
     DOUBLE PRECISION, Allocatable, Dimension(:) :: z
     DOUBLE PRECISION, Allocatable, Dimension(:) :: U
     DOUBLE PRECISION, Allocatable, Dimension(:) :: V
     DOUBLE PRECISION, Allocatable, Dimension(:) :: W
     DOUBLE PRECISION, Allocatable, Dimension(:) :: a
     DOUBLE PRECISION, Allocatable, Dimension(:) :: b
     DOUBLE PRECISION, Allocatable, Dimension(:) :: c
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Nx
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Ny
     DOUBLE PRECISION, Allocatable, Dimension(:) :: Nz
     DOUBLE PRECISION, Allocatable, Dimension(:) :: N1
     DOUBLE PRECISION, Allocatable, Dimension(:) :: N2
     DOUBLE PRECISION, Allocatable, Dimension(:) :: N3

    Allocate(x(3))
    Allocate(y(3))
    Allocate(z(3))
    Allocate(U(3))
    Allocate(V(3))
    Allocate(W(3))
    Allocate(a(3))
    Allocate(b(3))
    Allocate(c(3))
    Allocate(Nx(3))
    Allocate(Ny(3))
    Allocate(Nz(3))
    Allocate(N1(4))
    Allocate(N2(4))
    Allocate(N3(4))
    Allocate(BF(4))

    ! Reading the Original_Triangle vertex coordinates
    Do i=1,3
        x(i) = Node(i,2)
        y(i) = Node(i,3)
        z(i) = Node(i,4)
    End Do

    LNS1 = ele_normal(Cellindex,2)
    LNS2 = ele_normal(Cellindex,3)
    LNS3 = ele_normal(Cellindex,4)
    
    If(z(1).eq.z(2).and.z(1).eq.z(3)) Then
        If(LNS3.gt.0.0) Then
            Sinteta = 0.0
            Costeta = 1.0
            Sinphi = 0.0
            Cosphi = 1.0       
        Else
            Sinteta = 0.0
            Costeta = 1.0
            Sinphi = 0.0
            Cosphi = -1.0
        End If
        Else
        If(y(1).eq.y(2).and.y(1).eq.y(3)) Then
            If(LNS2.gt.0.0) Then
                Sinteta = 1.0
                Costeta = 0.0
                Sinphi = -1.0
                Cosphi =  0.0            
            Else
                Sinteta = -1.0
                Costeta = 0.0
                Sinphi = 1.0
                Cosphi = 0.0                
            End If
        Else
        If (x(1).eq.x(2).and.x(1).eq.x(3)) Then
             If(LNS1.gt.0.0) Then
                Sinteta = 0.0
                Costeta = 1.0
                Sinphi =  -1.0
                Cosphi = 0.0            
             Else
                Sinteta = 0.0
                Costeta = -1.0
                Sinphi =  1.0
                Cosphi = 0.0           
             End If
            Else
    Sxy = x(1)*(y(2)-y(3)) + x(2)*(y(3)-y(1)) + x(3)*(y(1)-y(2))
    Syz = y(1)*(z(2)-z(3)) + y(2)*(z(3)-z(1)) + y(3)*(z(1)-z(2))
    Szx = z(1)*(x(2)-x(3)) + z(2)*(x(3)-x(1)) + z(3)*(x(1)-x(2))
    Costeta = ((-1) * Syz)/((Syz**2 + Szx**2)**(0.5))
    Sinteta = ((-1) * Szx)/((Syz**2 + Szx**2)**(0.5))
    Cosphi = ((-1) * Sxy)/((Syz**2 + Szx**2 + Sxy**2)**(0.5))
    Sinphi = ((Syz**2 + Szx**2)/(Syz**2 + Szx**2 + Sxy**2))**(0.5)    
            End If
        End If
    End If
    Do i=1,3
        U(i) = x(i)* Cosphi * Costeta + y(i) * Sinteta * Cosphi - Sinphi * z(i)
        V(i) = (-1) * x(i)* Sinteta + y(i) * Costeta
        W(i) = x(i) * Sinphi * Costeta + y(i) * Sinphi * Sinteta + Cosphi * z(i)
    End Do    
    a(1) = U(2)*V(3) - V(2)*U(3)
    a(2) = U(3)*V(1) - V(3)*U(1)
    a(3) = U(1)*V(2) - V(1)*U(2)
    b(1) = V(2) - V(3)
    b(2) = V(3) - V(1)
    b(3) = V(1) - V(2)
    c(1) = U(3) - U(2)
    c(2) = U(1) - U(3)
    c(3) = U(2) - U(1)
    delta = (0.5) * (b(1)*c(2)-b(2)*c(1))
    Do i=1,3
        Nx(i) = b(i) * Costeta * Cosphi - c(i) * Sinteta
        Ny(i) = b(i) * Sinteta * Cosphi + c(i) * Costeta
        Nz(i) = (-1) * b(i) * Sinphi
    End Do
    N1(1) = (0.5/delta) * a(1)
    N1(2) = (0.5/delta) * Nx(1)
    N1(3) = (0.5/delta) * Ny(1)
    N1(4) = (0.5/delta) * Nz(1)
    BF(1) = (0.5/delta) * a(1)
    BF(2) = (0.5/delta) * Nx(1)
    BF(3) = (0.5/delta) * Ny(1)
    BF(4) = (0.5/delta) * Nz(1)
    Do i=1,3
    node_shape = BF(1) + BF(2) * Node(i,2) + BF(3) * Node(i,3) + BF(4) * Node(i,4)
    End Do
    !----------------------------------------------------------
    N2(1) = (0.5/delta) * a(2)
    N2(2) = (0.5/delta) * Nx(2)
    N2(3) = (0.5/delta) * Ny(2)
    N2(4) = (0.5/delta) * Nz(2)
    !----------------------------------------------------------
    N3(1) = (0.5/delta) * a(3)
    N3(2) = (0.5/delta) * Nx(3)
    N3(3) = (0.5/delta) * Ny(3)
    N3(4) = (0.5/delta) * Nz(3)
End Subroutine  Basis_Functions_Triangle
