Subroutine Global_Normal_Potential(Number_of_Nodes,Number_of_Cells,CCN,ele_normal,&
    &E_CON,A_CON,current,Node_coordinates,SL,integral_order,Cell_Node_Numbers,Potential_Electrod,nodal_normal_vector)

    Implicit None    
    
!==================================================================================================================
    ! Subroutine for Computation of the normal gradient of source potential (Right hand side of the final matrix equation)
    INTERFACE
    SUBROUTINE Normal_Gradient_Source_Potential(E_CON,A_CON,current,Number_of_Nodes,SL,nodal_normal_vector,Node_coordinates,RHS)
      Real, Allocatable, Dimension(:), INTENT(IN) :: SL
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(OUT) :: RHS
     ! RHS : Right Hand Side Matrix
     ! SL : Location of Electric Current Source
     Integer, INTENT(IN) :: Number_of_Nodes
      Real, INTENT(IN) :: E_CON,A_CON,current
    END SUBROUTINE Normal_Gradient_Source_Potential
    END INTERFACE
!==================================================================================================================
    ! Subroutine for Computation of the Left hand side of the final matrix equation
    INTERFACE
    SUBROUTINE Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,CCN,&
        &Cell_Node_Numbers,nodal_normal_vector,ele_normal,Node_coordinates,LHS)
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: LHS
     ! LHS : Left Hand Side Matrix (Coessicien Matrix in LHS C = RHS)
     Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON
    END SUBROUTINE Coefficient_Matrix
    END INTERFACE
!==================================================================================================================
    !Subroutine for Computation of the DC potential
    INTERFACE
    SUBROUTINE DC_Potential(E_CON,current,integral_order,Node_Coefficient_Electric_Charge,Number_of_Nodes,Number_of_Cells,&
    &SL,PEL,Node_coordinates,Cell_Node_Numbers,CCN,ele_normal,Half_Space_Potential,Anomaly_Potential,Potential)

    !DCP_ : DC Potential, The first letters of the subroutine's name    
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(IN) :: Node_Coefficient_Electric_Charge
      Real, Allocatable, Dimension(:), INTENT(IN) :: SL
      Real, Allocatable, Dimension(:), INTENT(IN) :: PEL
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,current
      DOUBLE PRECISION, INTENT(OUT) :: Potential
      DOUBLE PRECISION, INTENT(OUT) :: Half_Space_Potential
      DOUBLE PRECISION, INTENT(OUT) :: Anomaly_Potential
    END SUBROUTINE DC_Potential
    END INTERFACE
!==================================================================================================================
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Real, Allocatable, Dimension(:), INTENT(IN) :: SL
      Real, Allocatable, Dimension(:,:), INTENT(IN) :: Potential_Electrod
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON,current
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: nodal_normal_vector

!==================================================================================================================
    Integer :: ignp1
    DOUBLE PRECISION :: rgnp1,rgnp2,rgnp3,rgnp4
    ! ignp :: integer variable in the subroutine Global Normal Potential
    ! rgnp :: real variable in the subroutine Global Normal Potential
    Integer :: i,j,l,k
    Integer :: NRHS,LDA,LDB,INFO

    DOUBLE PRECISION :: normal_size
    DOUBLE PRECISION :: Potential
    DOUBLE PRECISION :: Half_Space_Potential
    DOUBLE PRECISION :: Anomaly_Potential

    Integer, Allocatable, Dimension(:) :: IPIV
    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: nodal_normal_vector
    DOUBLE PRECISION, Allocatable, Dimension(:) :: RHS
    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: LHS
    DOUBLE PRECISION, Allocatable, Dimension(:) :: Node_Coefficient_Electric_Charge
    Real, Allocatable, Dimension(:) :: PEL
    DOUBLE PRECISION, Allocatable, Dimension(:) :: N_Pole_Pole_DC


    Allocate(nodal_normal_vector(Number_of_Nodes,4))
    Allocate(RHS(Number_of_Nodes))
    Allocate(LHS(Number_of_Nodes,Number_of_Nodes))
    Allocate(IPIV(Number_of_Nodes))
    Allocate(Node_Coefficient_Electric_Charge(Number_of_Nodes))
    Allocate(PEL(3))
    Allocate(N_Pole_Pole_DC(251))
!==================================================================================================================
    ! Computation of the normal vector for each node by averaging the normal
    ! vectors of the cells which share that node
    Do i=1,Number_of_Nodes
          Do j=1,4
              nodal_normal_vector(i,j) = 0
          End Do
      End Do

      Open(10,file='Nodal_normal.txt')
      Open(20,file='Nodal_CCN.txt')
      Do j= 1,Number_of_Nodes
            rgnp1 = 0
            rgnp2 = 0
            rgnp3 = 0
            i = 0
            Write(20,*) "Node_Number : ", j
            Do l=2,Number_of_Cells+1
                ignp1 = CCN(j,l)               
                If (ignp1.ne.0) Then
                 Write(20,*) "Cell_Number : ", ignp1
                 i = i+1
                 rgnp1 = rgnp1 + ele_normal(ignp1,2)
                 rgnp2 = rgnp2 + ele_normal(ignp1,3)
                 rgnp3 = rgnp3 + ele_normal(ignp1,4)
                End If            
            End Do
            Write(20,*) "==========================="
            rgnp1 = rgnp1 / i
            rgnp2 = rgnp2 / i
            rgnp3 = rgnp3 / i
            normal_size = (rgnp1**2 + rgnp2**2 + rgnp3**2)**(0.5)
            nodal_normal_vector(j,1) = j
            nodal_normal_vector(j,2) = rgnp1 / normal_size
            nodal_normal_vector(j,3) = rgnp2 / normal_size
            nodal_normal_vector(j,4) = rgnp3 / normal_size
            rgnp4 = (nodal_normal_vector(j,2)**2 + nodal_normal_vector(j,3)**2 + nodal_normal_vector(j,4)**2)**(0.5)
            Write(10,*) "Node_Number : ", j
            Write(10,*) "Number of Cells that share tha node : ", i
            Write(10,*) "Normal_X_component : ", nodal_normal_vector(j,2)
            Write(10,*) "Normal_Y_component : ", nodal_normal_vector(j,3)
            Write(10,*) "Normal_Z_component : ", nodal_normal_vector(j,4)
            Write(10,*) "Normal_Size : ", rgnp4
            Write(10,*) "==========================="
      End Do
!==================================================================================================================
    ! Producing the right hand side of the final matrix equation which will
    ! be soleved for electrical charge node coefficients

    Call Normal_Gradient_Source_Potential(E_CON,A_CON,current,Number_of_Nodes,SL,nodal_normal_vector,Node_coordinates,RHS)

    Open(15,file='GNP_RHS.txt')
    Do i=1,Number_of_Nodes
        Write(15,*)   i, "   ", RHS(i)
    End Do
    
!==================================================================================================================
    ! Producing the Left hand side of the final matrix equation will
    ! be soleved for electrical charge node coefficients

    Call Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,CCN,&
        &Cell_Node_Numbers,nodal_normal_vector,ele_normal,Node_coordinates,LHS)
        open(30,file='GNP_LHS')
        Do i=1,Number_of_Nodes
            Write(30,*) "LHS(",i,",","1) : ","   ",LHS(i,1)
            Write(30,*) "LHS(",i,",","2) : ","   ",LHS(i,2)
            Write(30,*) "LHS(",i,",","3) : ","   ",LHS(i,3)
            Write(30,*) "LHS(",i,",","4) : ","   ",LHS(i,4)
            Write(30,*) "LHS(",i,",","5) : ","   ",LHS(i,5)
            Write(30,*) "LHS(",i,",","6) : ","   ",LHS(i,6)
            Write(30,*) "LHS(",i,",","7) : ","   ",LHS(i,7)
            Write(30,*) "LHS(",i,",","8) : ","   ",LHS(i,8)
            Write(30,*) "LHS(",i,",","9) : ","   ",LHS(i,9)
            Write(30,*) "LHS(",i,",","10) : ","   ",LHS(i,10)
            Write(30,*) "LHS(",i,",","11) : ","   ",LHS(i,11)
            Write(30,*) "LHS(",i,",","12) : ","   ",LHS(i,12)
            Write(30,*) "LHS(",i,",","13) : ","   ",LHS(i,13)
            Write(30,*) "LHS(",i,",","14) : ","   ",LHS(i,14)
            Write(30,*) "LHS(",i,",","15) : ","   ",LHS(i,15)
            Write(30,*) "LHS(",i,",","16) : ","   ",LHS(i,16)
            Write(30,*) "================================"
        End Do


!==================================================================================================================
   ! Solving the final matrix equation to produce the electrical charge node coefficients

    NRHS = 1
    LDA = Number_of_Nodes
    LDB = Number_of_Nodes

     Call dgesv(Number_of_Nodes,NRHS, LHS, LDA, IPIV, RHS, LDB, INFO)
     If (INFO/=0) Then
         Print*,'stop : INFO/=0',INFO
         Stop
     End If
     Do i=1,Number_of_Nodes
         Node_Coefficient_Electric_Charge(i) = RHS(i)
     End Do


     Open(15,file='GNP_Node_Coefficient_Electric_Charge.txt')
     Do i=1,Number_of_Nodes
         Write(15,*)  i , "     ", Node_Coefficient_Electric_Charge(i)
     End Do
!==================================================================================================================
     !Calculation of the DC electrical Potential

     Do i=1,251
        PEL(1) = Potential_Electrod(i,1)
        PEL(2) = Potential_Electrod(i,2)
        PEL(3) = Potential_Electrod(i,3)
    Call DC_Potential(E_CON,current,integral_order,Node_Coefficient_Electric_Charge,Number_of_Nodes,Number_of_Cells,&
    &SL,PEL,Node_coordinates,Cell_Node_Numbers,CCN,ele_normal,Half_Space_Potential,Anomaly_Potential,Potential)

    N_Pole_Pole_DC(i) = Anomaly_Potential

    End Do

    Open(20000,file='N_Pole_Pole_DC.txt')
    k=0
    Do i=1,251
    Write(20000,*)   k,"  ",N_Pole_Pole_DC(i)
    k = k+10
    End Do


End Subroutine Global_Normal_Potential






















