SUBROUTINE Local_Coefficient_Matrix(E_CON,A_CON,integral_order,Number_of_Nodes,Number_of_Cells,CCN,&
        &Cell_Node_Numbers,ele_normal,normal_vector,Node_coordinates,Local_LHS)

    Implicit None
!==================================================================================================================
     ! Subroutine for calculation of the transformed Shape(Basis) Function
    INTERFACE
    SUBROUTINE Basis_Functions_Triangle(Node,Cellindex,ele_normal,BF)
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(OUT) :: BF
      Integer, INTENT(IN) :: Cellindex

     ! BF : Basis Function
    END SUBROUTINE Basis_Functions_Triangle
    END INTERFACE
!==================================================================================================================
      ! Subroutine for numerical calculation of the integral for as specific cell
    INTERFACE
    Subroutine ThreeD_to_TwoD_Triangle_Transformation(Node,BF,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node
      DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(IN) :: BF   ! BF : Basis Function
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      Integer, INTENT(IN) :: integral_order,Cellindex
      DOUBLE PRECISION, INTENT(IN) :: xi,yi,zi
      DOUBLE PRECISION, INTENT(IN) :: n1,n2,n3
      DOUBLE PRECISION, INTENT(OUT) :: Int
    END SUBROUTINE ThreeD_to_TwoD_Triangle_Transformation
    END INTERFACE
!==================================================================================================================

      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: Cell_Node_Numbers
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
      Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: normal_vector
      DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: Local_LHS
     ! LHS : Left Hand Side Matrix (Coessicien Matrix in LHS C = RHS)
      Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells,integral_order
      Real, INTENT(IN) :: E_CON,A_CON
!==================================================================================================================
    Integer :: i,j,l,m,k,a1,a2,Cellindex,m1
     Real :: Kj,Pi,Epsilon0
     DOUBLE PRECISION :: xi,yi,zi
     DOUBLE PRECISION :: n1,n2,n3
     DOUBLE PRECISION :: Int,co1
     Real :: constant1,constant2


    DOUBLE PRECISION, Allocatable, Dimension(:,:) :: Node
    DOUBLE PRECISION, Allocatable, Dimension(:) :: BF
    

    Allocate(Local_LHS(Number_of_Nodes,Number_of_Nodes))
    Allocate(Node(3,4))
    Allocate(BF(4))


    Do i=1,3
        Do j=1,4
            Node(i,j) = 0.0
        End Do
    End Do
    Do i=1,4
        BF(i) = 0.0
    End Do

    Epsilon0 = 8.854187817620
    Pi = 3.141592
    Kj = ((E_CON - A_CON)/(E_CON + A_CON))        
    constant1 = (((-1) * Kj * (1.E12))/ (2 * Pi * Epsilon0))
    constant2 = (1.E12)/Epsilon0
    



    Do i=1,Number_of_Nodes
        Do j=1,Number_of_Nodes            
            co1 = 0
            Do l=2,Number_of_Cells+1
                a1 = CCN(j,l)
                If (a1.ne.0) Then
                m = 1
                Do k=2,4
                    a2 = Cell_Node_Numbers(a1,k)
                    If(a2.eq.j) Then
                        Node(1,1) = a2
                        Node(1,2) = Node_coordinates(j,2)
                        Node(1,3) = Node_coordinates(j,3)
                        Node(1,4) = Node_coordinates(j,4)
                    Else
                        m = m + 1
                        Node(m,1) = a2
                        Node(m,2) = Node_coordinates(a2,2)
                        Node(m,3) = Node_coordinates(a2,3)
                        Node(m,4) = Node_coordinates(a2,4)
                    End If
                End Do

                Cellindex = a1

                Call Basis_Functions_Triangle(Node,Cellindex,ele_normal,BF)

                xi = Node_coordinates(i,2)
                yi = Node_coordinates(i,3)
                zi = Node_coordinates(i,4)               

                n1 = normal_vector(i,2)
                n2 = normal_vector(i,3)
                n3 = normal_vector(i,4)

                Call ThreeD_to_TwoD_Triangle_Transformation(Node,BF,Cellindex,ele_normal,xi,yi,zi,n1,n2,n3,integral_order,Int)

                co1 = co1 + Int
                !Print*, "co1 = ", co1
                End If
            End Do
            Local_LHS(i,j) = constant1 * co1
            !Print*, "Local_LHS(",i,",",j,")",Local_LHS(i,j)            
        End Do
    End Do

     Do i=1,Number_of_Nodes
        Do j=1,Number_of_Nodes
            If(i.eq.j) Then
                Local_LHS(i,j) = constant2 - Local_LHS(i,j)                
            End If
        End Do
     End Do

End Subroutine Local_Coefficient_Matrix
