SUBROUTINE Matrix(MSFA,MSFB,MSF_Number_of_Nodes,LA,RB)

    Implicit None

    Real, Allocatable, Dimension(:,:), INTENT(IN) :: MSFA
    Real, Allocatable, Dimension(:), INTENT(IN) :: MSFB
    Real, Allocatable, Dimension(:,:), INTENT(OUT) :: LA
    Real, Allocatable, Dimension(:), INTENT(OUT) :: RB
    Integer, INTENT(IN) :: MSF_Number_of_Nodes

    Integer :: i,j,k

    Real, Allocatable, Dimension(:,:) :: TMSFA


    Allocate(LA(4,4))
    Allocate(RB(4))
    Allocate(TMSFA(4,MSF_Number_of_Nodes))

    Do i=1,4
        Do j=1,4
            LA(i,j) = 0.0
        End Do
    End Do

    Do i=1,4
        RB(i) = 0.0
    End Do

    Do i=1,MSF_Number_of_Nodes
        Do j=1,4
            TMSFA(j,i) = MSFA(i,j)
        End Do
    End Do

    Do i = 1, 4
         Do j = 1, 4
              Do k = 1, MSF_Number_of_Nodes
                   LA(i,j) = LA(i,j) + TMSFA(i,k) * MSFA(k,j)
              END Do
         END Do
    END Do

    Do i = 1, 4
         Do j = 1, 1
              Do k = 1, MSF_Number_of_Nodes
                   RB(i) = RB(i) + TMSFA(i,k) * MSFB(k)
              END Do
         END Do
    END Do

End Subroutine

