    SUBROUTINE Nodal_Normal_Vector(CCN,Number_of_Nodes,Number_of_Cells,ele_normal,normal_vector)

        Implicit None
!==================================================================================================================     
     Integer, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
     DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: ele_normal
     DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: normal_vector
     Integer, INTENT(IN) :: Number_of_Nodes,Number_of_Cells
!==================================================================================================================
     Integer :: i,j,l,CO5
     DOUBLE PRECISION :: CO1,CO2,CO3,CO4
     DOUBLE PRECISION :: normal_size

     Allocate(normal_vector(Number_of_Nodes,4))
     
!==================================================================================================================    
      Do i=1,Number_of_Nodes
          Do j=1,4
              normal_vector(i,j) = 0
          End Do
      End Do
!==================================================================================================================      
      Do j= 1,Number_of_Nodes
            CO1 = 0
            CO2 = 0
            CO3 = 0
            i = 0            
            Do l=2,Number_of_Cells+1
                CO5 = CCN(j,l)
                If (CO5.ne.0) Then
                 i = i+1
                 CO1 = CO1 + ele_normal(CO5,2)
                 CO2 = CO2 + ele_normal(CO5,3)
                 CO3 = CO3 + ele_normal(CO5,4)
                End If
            End Do            
            CO1 = CO1 / i
            CO2 = CO2 / i
            CO3 = CO3 / i
            normal_size = (CO1**2 + CO2**2 + CO3**2)**(0.5)
            normal_vector(j,1) = j
            normal_vector(j,2) = CO1 / normal_size
            normal_vector(j,3) = CO2 / normal_size
            normal_vector(j,4) = CO3 / normal_size
            CO4 = (normal_vector(j,2)**2 + normal_vector(j,3)**2 + normal_vector(j,4)**2)**(0.5)
      End Do
      Open(7001, file = 'normal_vector.txt')
      Do i=1,Number_of_Nodes
          write(7001,*) normal_vector(i,1),"   ",normal_vector(i,2),"   ",normal_vector(i,3),"   ",normal_vector(i,4)
      End Do
!==================================================================================================================

    END SUBROUTINE Nodal_Normal_Vector
