SUBROUTINE Normal_Gradient_Source_Potential(E_CON,A_CON,current,Number_of_Nodes,SL,nodal_normal_vector,Node_coordinates,RHS)
        

    Implicit None
!==================================================================================================================
    Real, Allocatable, Dimension(:), INTENT(IN) :: SL
    DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: nodal_normal_vector
    DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
    DOUBLE PRECISION, Allocatable, Dimension(:), INTENT(OUT) :: RHS

    Integer, INTENT(IN) :: Number_of_Nodes
    Real, INTENT(IN) :: E_CON,A_CON,current
!==================================================================================================================
    Integer :: i,j
    Real :: C,Pi,Kj
    DOUBLE PRECISION :: Nom1,Nom2,Nom3,Nom4,Den1,Den2
    DOUBLE PRECISION :: n1,n2,n3,xi,yi,zi

    DOUBLE PRECISION, Allocatable, Dimension(:) :: RHS

    Allocate(RHS(Number_of_Nodes))
!==================================================================================================================
    Pi = 3.141592
    Kj = (E_CON - A_CON)/(E_CON + A_CON)
    C = (current * Kj)/(2 * Pi * E_CON)
!==================================================================================================================
    Do i=1,Number_of_Nodes
        RHS(i) = 0.0
    End Do

    Do i=1,Number_of_Nodes

        xi = Node_coordinates(i,2)
        yi = Node_coordinates(i,3)
        zi = Node_coordinates(i,4)

        n1 = nodal_normal_vector(i,2)
        n2 = nodal_normal_vector(i,3)
        n3 = nodal_normal_vector(i,4)


        Nom1 = n1 * (SL(1) - xi)
        Nom2 = n2 * (SL(2) - yi)
        Nom3 = n3 * (SL(3) - zi)
        Nom4 = n3 * (-1) * (SL(3) + zi)

        Den1 =  ((xi - SL(1))**2 + (yi - SL(2))**2 + (zi - SL(3))**2)**(1.5)
        Den2 =  ((xi - SL(1))**2 + (yi - SL(2))**2 + (zi + SL(3))**2)**(1.5)

        RHS(i) = C * (((Nom1+Nom2+Nom3)/(Den1)) + ((Nom1+Nom2+Nom4)/(Den2)))
    End Do
!==================================================================================================================
End SUBROUTINE