 SUBROUTINE Sphere_Fitting(Number_of_Nodes,SF_Number_of_Cells,normal_vector,centroid,CCN,SF_Cell_Node_Numbers,&
     &SF_Node_coordinates,S_Normal)

        Implicit None
    !--------------------------------------------------------------------------
    ! Subroutine for foing matrix manipulation
    INTERFACE
    SUBROUTINE Matrix(MSFA,MSFB,MSF_Number_of_Nodes,LA,RB)
     Real, Allocatable, Dimension(:,:), INTENT(IN) :: MSFA
     Real, Allocatable, Dimension(:), INTENT(IN) :: MSFB
     Real, Allocatable, Dimension(:,:), INTENT(OUT) :: LA
     Real, Allocatable, Dimension(:), INTENT(OUT) :: RB
     Integer, INTENT(IN) :: MSF_Number_of_Nodes
    END SUBROUTINE Matrix
    END INTERFACE
    !--------------------------------------------------------------------------
     !SF_ : Sphere_Fitting, The first letters of the subroutine's name
     Real, Allocatable, Dimension(:,:), INTENT(IN) :: SF_Cell_Node_Numbers
     Real, Allocatable, Dimension(:,:), INTENT(IN) :: SF_Node_coordinates
     Real, Allocatable, Dimension(:), INTENT(IN) :: centroid
     Real, Allocatable, Dimension(:,:), INTENT(IN) :: normal_vector
     Real, Allocatable, Dimension(:,:), INTENT(IN) :: CCN
     Real, Allocatable, Dimension(:,:), INTENT(OUT) :: S_Normal
     Integer, INTENT(IN) :: SF_Number_of_Nodes,SF_Number_of_Cells

     !--------------------------------------------------------------------------

     Integer :: i,j,l,l1,m,k,index1,a1,a2,cond1,cond2,h
     Integer :: NRHS,LDA,LDB,INFO
     Integer :: MSF_Number_of_Nodes

     Integer :: cond,cond1,cond2,cond3
     Real :: XP,YP,ZP,XP1,YP1,ZP1

     Real :: X_Sphere_center,Y_Sphere_center,Z_Sphere_center, Radius,inp,Cosomega,omega
     Real :: vector2_size,vector1_size
     Real :: S1,S2,S3,S4

     Real, Allocatable, Dimension(:,:) :: Node_neighbor1
     Real, Allocatable, Dimension(:,:) :: Node_neighbor
     Real, Allocatable, Dimension(:,:) :: Node_neighbor2
     Real, Allocatable, Dimension(:,:) :: SFA
     Real, Allocatable, Dimension(:) :: SFB
     Real, Allocatable, Dimension(:,:) :: MSFA
     Real, Allocatable, Dimension(:) :: MSFB
     Real, Allocatable, Dimension(:,:) :: LA
     Real, Allocatable, Dimension(:) :: RB
     Real, Allocatable, Dimension(:) :: vector1
     Real, Allocatable, Dimension(:) :: vector2
     Real, Allocatable, Dimension(:) :: IPIV

     index1 = SF_Number_of_Cells * 3 + 1

     Allocate(IPIV(4))
     Allocate(S_Normal(SF_Number_of_Nodes,4))
     Allocate(Node_neighbor1(SF_Number_of_Nodes,index1))
     Allocate(Node_neighbor(SF_Number_of_Nodes,SF_Number_of_Cells))
     Allocate(Node_neighbor2(SF_Number_of_Nodes,SF_Number_of_Nodes))
     Allocate(SFA(SF_Number_of_Nodes,4))
     Allocate(SFB(SF_Number_of_Nodes))
     Allocate(MSFA(SF_Number_of_Nodes,4))
     Allocate(MSFB(SF_Number_of_Nodes))
     Allocate(LA(4,4))
     Allocate(RB(4))
     Allocate(vector1(3))
     Allocate(vector2(3))

     Do i=1,SF_Number_of_Nodes
         Do j=1,index1
             Node_neighbor1(i,j) = 0
         End Do
     End Do

     Do i=1,SF_Number_of_Nodes
         Do j=1,SF_Number_of_Cells
             Node_neighbor(i,j) = 0
         End Do
     End Do

     Do i=1,SF_Number_of_Nodes
         Do j=1,4
             SFA(i,j) = 0
         End Do
     End Do

     Do i=1,SF_Number_of_Nodes
             SFB(i) = 0
     End Do


     Do i=1,SF_Number_of_Nodes
         m = 2
         Node_neighbor1(i,1) = i
         Do j=2,SF_Number_of_Cells+1
            a1 = CCN(i,j)
                If (a1.ne.0) Then
                Do k=2,4
                    a2 = SF_Cell_Node_Numbers(a1,k)
                    Node_neighbor1(i,m) = a2
                    m = m + 1
                End Do
                End If
         End Do
     End Do


     open(85,file='node_neighbour1.txt')
     Do i=1,SF_Number_of_Nodes
         write(85,*) Node_neighbor1(i,1),"  ",Node_neighbor1(i,2),"  ",Node_neighbor1(i,3),"  ",Node_neighbor1(i,4)&
         &,"  ",Node_neighbor1(i,5),"  ",Node_neighbor1(i,6),"  ",Node_neighbor1(i,7),"  ",Node_neighbor1(i,8),"  ",&
         &Node_neighbor1(i,9),"  ",Node_neighbor1(i,10),"  ",Node_neighbor1(i,11),"  ",Node_neighbor1(i,12)&
         ,"   ",Node_neighbor1(i,13)
     End Do

     Do i=1,SF_Number_of_Nodes
         Node_neighbor(i,1) = i
         k = 1
         Do j=2,index1
             a1 = Node_neighbor1(i,j)
             cond2 = 0.0
             Do l=1,k
                 a2 = Node_neighbor(i,l)
                 If(a1.eq.a2.or.a1.eq.i.or.a1.eq.0.0) Then
                     cond1 = 1.0
                     cond2 = 1.0
                 Else
                     cond1 = 0.0
                 End If
             End Do
                 If(cond1.eq.0.0.and.cond2.eq.0.0) Then
                     k = k+1
                     Node_neighbor(i,k) = a1
                 End If
         End Do
     End Do

     open(95,file='node_neighbour.txt')
     Do i=1,SF_Number_of_Nodes
        write(95,*) Node_neighbor(i,1),"  ",Node_neighbor(i,2),"  ",Node_neighbor(i,3),"  ",Node_neighbor(i,4)&
         &,"  ",Node_neighbor(i,5),"  ",Node_neighbor(i,6),"  ",Node_neighbor(i,7),"  ",Node_neighbor(i,8),"  ",&
         &Node_neighbor(i,9),"  ",Node_neighbor(i,10),"  ",Node_neighbor(i,11),"  ",Node_neighbor(i,12)
     End Do

     Do i=1,SF_Number_of_Nodes
         Do j=1,SF_Number_of_Nodes
             Node_neighbor2(i,j) = Node_neighbor(i,j)
         End Do
     End Do

     open(110,file='node_neighbour2.txt')
     Do i=1,SF_Number_of_Nodes
        write(110,*) Node_neighbor2(i,1),"  ",Node_neighbor2(i,2),"  ",Node_neighbor2(i,3),"  ",Node_neighbor2(i,4)&
         &,"  ",Node_neighbor2(i,5),"  ",Node_neighbor2(i,6),"  ",Node_neighbor2(i,7),"  ",Node_neighbor2(i,8)
     End Do

     Do i=1,SF_Number_of_Nodes
         Do j=1,SF_Number_of_Nodes
           a1 = Node_neighbor2(i,j)
           If(a1.ne.0) Then
           SFA(j,1) = SF_Node_coordinates(a1,2)
           SFA(j,2) = SF_Node_coordinates(a1,3)
           SFA(j,3) = SF_Node_coordinates(a1,4)
           SFA(j,4) = 1
           SFB(j) = SFA(j,1)**2 + SFA(j,2)**2 + SFA(j,3)**2
           Else
           SFA(j,1) = 0
           SFA(j,2) = 0
           SFA(j,3) = 0
           SFA(j,4) = 0
           SFB(j) = 0
           End If
         End Do
         cond = 0
         cond1 = 0
         cond2 = 0
         cond3 = 0
         XP = SFA(1,1)
         Do l=2,SF_Number_of_Nodes
             XP1 = SFA(l,1)
             If(XP1.ne.0) Then
                 If(XP.eq.XP1) Then
                    cond = 0
                 Else
                    cond = 1
                    cond1 = 1
                 End If
             End If
         End Do
         YP = SFA(1,2)
         Do m=2,SF_Number_of_Nodes
             YP1 = SFA(m,2)
             If(YP1.ne.0) Then
                 If(YP.eq.YP1) Then
                    cond = 0
                 Else
                    cond = 1
                    cond2 = 1
                 End If
             End If
         End Do
        ZP = SFA(1,3)
         Do l1=2,SF_Number_of_Nodes
             ZP1 = SFA(l1,3)
             If(ZP1.ne.0) Then
                 If(ZP.eq.ZP1) Then
                    cond = 0
                 Else
                    cond = 1
                    cond3 = 1
                 End If
             End If
         End Do

         If(cond1.eq.0.or.cond2.eq.0.or.cond3.eq.0) Then
         Open(100,file = 'Plane_Sittuation.txt')
         write(100,*)   "Node = ", i
         write(100,*)   "S_Normal(",i,",1) = ", i
         write(100,*)   "S_Normal(",i,",2) = ",normal_vector(i,2)
         write(100,*)   "S_Normal(",i,",3) = ",normal_vector(i,3)
         write(100,*)   "S_Normal(",i,",4) = ",normal_vector(i,4)
         write(100,*) "#############################################"
         S_Normal(i,1) = i
         S_Normal(i,2) = normal_vector(i,2)
         S_Normal(i,3) = normal_vector(i,3)
         S_Normal(i,4) = normal_vector(i,4)

         Else

         Call Matrix(SFA,SFB,SF_Number_of_Nodes,LA,RB)
         NRHS = 1
         LDA = 4
         LDB = 4
     Call sgesv(LDA,NRHS, LA, LDA, IPIV, RB, LDB, INFO)
     If (INFO.ne.0) Then
         Open(95,file = 'Sphere_Fitting_Crash.txt')
         write(95,*)   "stop : INFO/=0",INFO
         write(95,*)   "Node = ", i
         write(95,*)   "S_Normal(",i,",1) = ", i
         write(95,*)   "S_Normal(",i,",2) = ",normal_vector(i,2)
         write(95,*)   "S_Normal(",i,",3) = ",normal_vector(i,3)
         write(95,*)   "S_Normal(",i,",4) = ",normal_vector(i,4)
         write(95,*) "#############################################"
         S_Normal(i,1) = i
         S_Normal(i,2) = normal_vector(i,2)
         S_Normal(i,3) = normal_vector(i,3)
         S_Normal(i,4) = normal_vector(i,4)
     Else
         X_Sphere_center = RB(1)/2.0
         Y_Sphere_center = RB(2)/2.0
         Z_Sphere_center = RB(3)/2.0
         Radius = (RB(4) + X_Sphere_center**2 + Y_Sphere_center**2 + Z_Sphere_center**2)**(0.5)
         vector1(1) = SF_Node_coordinates(i,2) - X_Sphere_center
         vector1(2) = SF_Node_coordinates(i,3) - Y_Sphere_center
         vector1(3) = SF_Node_coordinates(i,4) - Z_Sphere_center
         vector2(1) = centroid(1) - SF_Node_coordinates(i,2)
         vector2(2) = centroid(2) - SF_Node_coordinates(i,3)
         vector2(3) = centroid(3) - SF_Node_coordinates(i,4)
         vector2_size = (vector2(1)**2 + vector2(2)**2 + vector2(3)**2)**(0.5)
         vector1_size = (vector1(1)**2 + vector1(2)**2 + vector1(3)**2)**(0.5)
         inp = vector2(1)*vector1(1) + vector2(2)*vector1(2) + vector2(3)*vector1(3)
         Cosomega = inp / (vector1_size*vector2_size)
         If(Cosomega.gt.1) Then
             Cosomega = 1.0
         End If
         If(Cosomega.lt.(-1)) Then
             Cosomega = -1.0
         End If
         omega = acos(Cosomega)
         If(omega.gt.1.5707964) Then
            S_Normal(i,1) = i
            S_Normal(i,2) = vector1(1)/vector1_size
            S_Normal(i,3) = vector1(2)/vector1_size
            S_Normal(i,4) = vector1(3)/vector1_size
         Else
            S_Normal(i,1) = i
            S_Normal(i,2) = ((-1) * vector1(1))/vector1_size
            S_Normal(i,3) = ((-1) * vector1(2))/vector1_size
            S_Normal(i,4) = ((-1) * vector1(3))/vector1_size

         End If

     End If
      End If
     S1 = S_Normal(i,1)
     S2 = S_Normal(i,2)
     S3 = S_Normal(i,3)
     S4 = S_Normal(i,4)
     End Do

     open(105,file='S_Normal.txt')
     Do i=1,SF_Number_of_Nodes
     write(105,*)   S_Normal(i,1),"   ",S_Normal(i,2),"   ",S_Normal(i,3),"   ",S_Normal(i,4),&
     &"     ",((S_Normal(i,2))**2 + (S_Normal(i,3))**2 + (S_Normal(i,4))**2)**(0.5)
     End Do

 END SUBROUTINE Sphere_Fitting

