Subroutine Sphere_Nodal_Normal(Node_coordinates,Sphere,Number_of_Nodes,S_Normal)

     Implicit None
     DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(IN) :: Node_coordinates
     Real, Allocatable, Dimension(:), INTENT(IN) :: Sphere
     DOUBLE PRECISION, Allocatable, Dimension(:,:), INTENT(OUT) :: S_Normal
     Integer, INTENT(IN) :: Number_of_Nodes

     Integer :: i
     Real :: Xc,Yc,Zc,Radius,SAN_Size,a1,a2,a3,SAN_Size1

     Allocate(S_Normal(Number_of_Nodes,4))

     Xc = Sphere(1)
     Yc = Sphere(2)
     Zc = Sphere(3)
     Radius = Sphere(4)

     
     Do i=1,Number_of_Nodes
 SAN_Size = ((Node_coordinates(i,2) - Xc)**2 + (Node_coordinates(i,3) - Yc)**2 + (Node_coordinates(i,4) - Zc)**2)**(0.5)
         S_Normal(i,1) = i
         S_Normal(i,2) = (Node_coordinates(i,2) - Xc)/SAN_Size
         a1 = (Node_coordinates(i,2) - Xc)/SAN_Size
         S_Normal(i,3) = (Node_coordinates(i,3) - Yc)/SAN_Size
         a2 = (Node_coordinates(i,3) - Yc)/SAN_Size
         S_Normal(i,4) = (Node_coordinates(i,4) - Zc)/SAN_Size
         a3 = (Node_coordinates(i,4) - Zc)/SAN_Size
         SAN_Size1 = (a1**2 + a2**2 + a3**2)**(0.5)         
     End Do
End Subroutine
